package fr.lri.insitu.FlowStates.examples.graphicalEditor;

import java.awt.geom.Point2D;

import fr.lri.insitu.FlowStates.examples.graphicalEditor.events.RubberBand;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.insitu.FlowStates.transitions.SwitchOnPosition;
import fr.lri.swingstates.canvas.Canvas;
import fr.lri.swingstates.sm.State;
import fr.lri.swingstates.sm.Transition;
import fr.lri.swingstates.sm.transitions.EventOnPosition;

public class PanInteraction extends IConStateMachine {

	Point2D previousPoint;
	
	public PanInteraction(String name, Canvas c) {
		super(name, c);
	}

//	State noPanning = new State() {
//		Transition startPanning = new EventOnPosition(RubberBand.class) {
//			public void action() {
//				if (((RubberBand)getEvent()).getSlotOn()) {
//					if(previousPoint != null) {
//						double dx = getPoint().getX() - previousPoint.getX();
//						double dy = getPoint().getY() - previousPoint.getY();
//						((ZoomableCanvas)getCanvas()).panBy(dx, dy); 
//					}
//					previousPoint = getPoint();
//				}
//			}
//		};
//
//	};
	
	State noPanning = new State() {
		Transition startPanning = new SwitchOnPosition(RubberBand.class, SWITCH_ON, ">> panning") {
			public void action() {
				previousPoint = getPoint();
			}
		};
	};
	State panning = new State() {
		Transition stopPanning = new SwitchOnPosition(RubberBand.class, SWITCH_OFF, ">> noPanning") { };
		Transition startPanning = new EventOnPosition(RubberBand.class) {
			public void action() {
				double dx = getPoint().getX() - previousPoint.getX();
				double dy = getPoint().getY() - previousPoint.getY();
				((ZoomableCanvas)getCanvas()).panBy(dx, dy); 
				previousPoint = getPoint();
			}
		};
	};

}
