package fr.lri.insitu.FlowStates.examples.menus;

import fr.lri.swingstates.canvas.CEllipse;
import fr.lri.swingstates.canvas.CPolyLine;
import fr.lri.swingstates.canvas.CShape;
import fr.lri.swingstates.canvas.CText;
import fr.lri.swingstates.canvas.Canvas;

public class CircularMenuLayout_OLD extends MenuLayout {

	public CircularMenuLayout_OLD(Canvas canvas, String[] items) {
		super(canvas);
		parent = canvas.newEllipse(-5, -5, 10, 10);
		parent.addTag(parentShape);
		
		CShape clipCircle = (new CEllipse(-50, -50, 100, 100)).getSubtraction(new CEllipse(-30, -30, 60, 60));
		clipCircle.setFilled(false).setOutlined(false);
		clipCircle.addTag(tagWhole).setParent(parent);

		CPolyLine bgItem;
		CText labelItem;
		double angleStep = 2 * Math.PI / items.length;
		for (int i = 0; i < items.length; i++) {
			bgItem = canvas.newPolyLine(0, 0).lineTo(50, 0).arcTo(0, -angleStep, 50, 50).close();
			bgItem.addTag(tagWhole).addTag(tagBg).addTag(new MenuItem(items[i])).setReferencePoint(0, 0).rotateBy(i * angleStep).setFillPaint(BG_COLOR_DEFAULT).setOutlinePaint(BORDER_COLOR_DEFAULT).setClip(clipCircle);

			labelItem = (CText) canvas.newText(0, 0, items[i], MenuLayout.FONT).setPickable(false).addTag(tagWhole).addTag(tagLabels).setReferencePoint(0.5, 0.5).translateTo(
					Math.cos((i * angleStep) + angleStep / 2) * 40, Math.sin((i * angleStep) + angleStep / 2) * 40);

			parent.addChild(labelItem).addChild(bgItem);

		}

		parent.addTag(tagWhole);
		tagLabels.aboveAll();
		parent.aboveAll();
	}
	
}
