package fr.lri.insitu.FlowStates.examples.menus;

import java.awt.geom.Point2D;

import fr.lri.swingstates.canvas.CRectangle;
import fr.lri.swingstates.canvas.CShape;
import fr.lri.swingstates.canvas.CText;
import fr.lri.swingstates.canvas.Canvas;

public class LinearMenuLayout extends MenuLayout {
 
	public LinearMenuLayout(Canvas canvas, String[] items) {
		super(canvas);
		parent = canvas.newRectangle(-1, -1, 2, 2);
		parent.setDrawable(false).setPickable(false);
		parent.addTag(parentShape);
		
	    bgShape = canvas.newRectangle(0, 0, 60, items.length*20);
		bgShape.addTo(canvas);
		bgShape.addTag(tagWhole)
		//.addTag(tagBg)
		.setOutlined(false)
		.setOutlined(false);
		bgShape.setFillPaint(backgroundColor);
		parent.addChild(bgShape);
		
		CRectangle bgItem;
		CText labelItem;
		for(int i = 0; i < items.length; i++) {
			bgItem = canvas.newRectangle(0, i*20, 60, 20);
			bgItem.addTag(tagWhole).addTag(tagItemBg).addTag(new MenuItem(items[i]))
			.setFillPaint(itemsBackgroundColor).setOutlinePaint(borderColor);

			labelItem = (CText) canvas.newText(0, 0, items[i], MenuLayout.FONT).setPickable(false)
			.addTag(tagWhole).addTag(tagLabels)
			.setReferencePoint(0, 0.5).translateTo(3, bgItem.getCenterY());

			parent.addChild(labelItem).addChild(bgItem);

		}

		hideMenu();
	}
	
	public void showMenu(Point2D pt) {
		super.showMenu(pt);
		parent.setDrawable(false);
	}

	
}
