package fr.lri.insitu.FlowStates.examples.simplePanZoom;

import java.awt.geom.Point2D;

import fr.lri.insitu.FlowStates.examples.graphicalEditor.ZoomableCanvas;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.swingstates.sm.State;
import fr.lri.swingstates.sm.Transition;
import fr.lri.swingstates.sm.transitions.Event;

public class ZoomInteraction extends IConStateMachine {

	public ZoomInteraction(String name, ZoomableCanvas c) {
		super(name, c);
	}

	State idle = new State() {
		Transition zoom = new Event(Zoom.class) {
			public void action() {
				
				double zoomMin = 0.01;
				double deltaZ = Math.pow(zoomMin, 1.0/getCanvas().getHeight());
				
				Zoom event = (Zoom)getEvent();
				double dz = 1;
				if(event.getSlotDZ() > 0)
					dz = Math.pow(deltaZ, event.getSlotDZ());
				else
					dz = 1.0/Math.pow(deltaZ, -event.getSlotDZ());
				
				((ZoomableCanvas)getCanvas()).zoomBy(new Point2D.Double(event.getSlotX(), event.getSlotY()), dz);
			}
		};
	};

}
