package fr.lri.insitu.FlowStates.examples.toolglass;

import java.awt.geom.Point2D;

import javax.swing.JFrame;

import fr.lri.insitu.FlowStates.IConEnvironnement;
import fr.lri.insitu.FlowStates.examples.toolglass.events.TensionOn;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.insitu.FlowStates.transitions.Switch;
import fr.lri.insitu.FlowStates.transitions.SwitchOnPosition;
import fr.lri.insitu.FlowStates.transitions.SwitchOnTag;
import fr.lri.swingstates.canvas.CRectangularShape;
import fr.lri.swingstates.canvas.Canvas;
import fr.lri.swingstates.sm.State;
import fr.lri.swingstates.sm.Transition;
import fr.lri.swingstates.sm.transitions.EventOnPosition;

public class ToolPalette {

	protected IConStateMachine shapeCreation;
	protected Canvas canvas;
	protected Palette palette;
	
	public ToolPalette(Canvas canvas, JFrame frame) {
		this.canvas = canvas;
		
		palette = new Palette(canvas);
		
		shapeCreation = new IConStateMachine("shapeCreation", canvas) {
			CRectangularShape currentShape = null;
			Point2D p1, p2;
			Tool currentTool;
			
			State noTool = new State() {
				Transition on = new SwitchOnTag(Tool.class, TensionOn.class, SWITCH_ON, ">> tool") {
					public void action() {
						currentTool = (Tool)getTag();
					}
				};
			};
			
			State tool = new State() {
				Transition newTool = new SwitchOnTag(Tool.class, TensionOn.class, SWITCH_ON) {
					public void action() {
						currentTool = (Tool)getTag();
					}
				};
				Transition startDraw = new SwitchOnPosition(TensionOn.class, SWITCH_ON, ">> draw") {
					public void action() {
						p1 = getPoint();
						currentShape = currentTool.getShape(p1.getX(), p1.getY());
					}
				};
			};
			State draw = new State() {
				Transition off = new Switch(TensionOn.class, SWITCH_OFF, ">> tool") { };
				
				Transition rubberBand = new EventOnPosition(TensionOn.class) {
					public void action() {
						currentShape.setDiagonal(p1, getPoint());
					}
				};
			};
		};
		
		IConEnvironnement.addStateMachine(shapeCreation, frame, canvas);
		
	}
	
	public static void main(String[] args) {
		Canvas canvas = new Canvas (600, 400);
		JFrame frame = new JFrame();
		ToolPalette toolPalette = new ToolPalette(canvas, frame);
		frame.getContentPane().add(canvas);
		frame.pack();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		IConEnvironnement.start();
		
		IConEnvironnement.start("palette.ic");
		
	}
}
