package fr.lri.insitu.FlowStates.device;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.LinkedList;

import fr.emn.reactiveinput.Out;
import fr.emn.reactiveinput.SlotType;
import fr.lri.insitu.FlowStates.events.InSlotEvent;
import fr.lri.insitu.FlowStates.events.OutSlotEvent;

public class OutSlotsGroup {

	private Class<? extends OutSlotEvent> evClass;
	
	public Class<? extends OutSlotEvent> getEvClass() {
		return evClass;
	}

	private LinkedList<Out> slots = new LinkedList<Out>();
	private LinkedList<Method> methods = new LinkedList<Method>();
	
	public OutSlotsGroup(Class<? extends OutSlotEvent> evClass) {
		this.evClass = evClass;
	}
	
	public void addSlot(Out slot, Method m) {
		slots.add(slot);
		methods.add(m);
	}

	public void updateSlots(OutSlotEvent event) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {

		for (int i = 0; i < slots.size(); i++) {
			Out slot = slots.get(i);
			Method m = methods.get(i);
			Object value = m.invoke(event, new Object[]{});
			switch (slot.getType()) {
				case SlotType.BOOLEAN:
					slot.setBooleanValue((Boolean)value);
					break;
				case SlotType.DOUBLE:
					slot.setDoubleValue((Double)value);
					break;
				case SlotType.INT:
					slot.setIntValue((Integer)value);
					break;
				case SlotType.STRING:
					slot.setStringValue((String)value);
					break;	
				default:
					slot.setObjectValue(value);	
			}
		}
	}

	public LinkedList<Out> getSlots() {
		return slots;
	}
}
