package fr.lri.insitu.FlowStates.transitions;

import java.util.EventObject;

import fr.lri.insitu.FlowStates.events.ICSwitchEvent;
import fr.lri.swingstates.sm.transitions.EventOnPosition;

public class SwitchOnPosition extends EventOnPosition {
	
	protected boolean on;
	
	public SwitchOnPosition(Class<? extends ICSwitchEvent> eventClass, boolean on, String outState) {
		super(eventClass, outState);
		this.on = on;
	}

	public SwitchOnPosition(Class<? extends ICSwitchEvent> eventClass, boolean on) {
		super(eventClass);
		this.on = on;
	}
	
	public boolean matches(EventObject eventObject) {
		if(!(eventObject instanceof ICSwitchEvent)) {
			return false;
		}
		ICSwitchEvent icSwitchEvent = (ICSwitchEvent)eventObject;
		return (icSwitchEvent.hasSwitchValueChanged() && icSwitchEvent.getSlotOn() == on)
			&& super.matches(eventObject);
	}
	
	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		String switchValue = on ? "SWITCH_ON" : "SWITCH_OFF";
		if(classEvent != null) return "SwitchOnPosition("+classEvent.getSimpleName()+".class"+", "+ switchValue+")";
		else return "SwitchOnPosition("+event+", "+ switchValue+")";
	}

}
