package fr.lri.insitu.FlowStates.transitions;

import java.util.EventObject;

import fr.lri.insitu.FlowStates.events.ICSwitchEvent;
import fr.lri.swingstates.canvas.CTag;
import fr.lri.swingstates.canvas.transitions.EventOnTag;

public class SwitchOnTag extends EventOnTag {

	protected boolean on;
	
	public SwitchOnTag(Class<? extends CTag> tgClass, Class<? extends ICSwitchEvent> eventClass, boolean on, String outState) {
		super(tgClass, eventClass, outState);
		this.on = on;
	}

	public SwitchOnTag(Class<? extends CTag> tagClass, Class<? extends ICSwitchEvent> eventClass, boolean on) {
		super(tagClass, eventClass);
		this.on = on;
	}

	public SwitchOnTag(CTag tag, Class<? extends ICSwitchEvent> eventClass, boolean on, String outState) {
		super(tag, eventClass, outState);
		this.on = on;
	}

	public SwitchOnTag(CTag tag, Class<? extends ICSwitchEvent> eventClass, boolean on) {
		super(tag, eventClass);
		this.on = on;
	}

	public SwitchOnTag(String tagName, Class<? extends ICSwitchEvent> eventClass, boolean on, String outState) {
		super(tagName, eventClass, outState);
		this.on = on;
	}

	public SwitchOnTag(String tagName, Class<? extends ICSwitchEvent> eventClass, boolean on) {
		super(tagName, eventClass);
		this.on = on;
	}
	
	public boolean matches(EventObject eventObject) {
		if(!(eventObject instanceof ICSwitchEvent)) {
			return false;
		}
		ICSwitchEvent icSwitchEvent = (ICSwitchEvent)eventObject;
		if(icSwitchEvent.hasSwitchValueChanged() && icSwitchEvent.getSlotOn() == on)
			return super.matches(eventObject);
		else
			return false;
	}
	
	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		String evt = classEvent != null ? classEvent.getSimpleName() + ".class" : event;
		String switchValue = on ? "SWITCH_ON" : "SWITCH_OFF";
		if (isDesignedByClass) {
			return "SwitchOnTag(" + tagClass.getSimpleName() + ".class, "+ evt + ", "+switchValue+")";
		} else {
			if (isNamed)
				return "SwitchOnTag(\"" + tagName + "\", " + evt +", "+ switchValue + ")";
			else {
				Class<?> tgClass = tagObject.getClass();
				while(tgClass.isAnonymousClass())
					tgClass = tgClass.getSuperclass();
				String id = tagObject.toString().substring(tagObject.toString().lastIndexOf('@'));
				return "SwitchOnTag(" + tgClass.getSimpleName()+id + ", " + evt +", "+switchValue+")";
			}
		}
	}

}
